*CMZ :          01/02/96  13.32.07  by  Eugene H. Sevinian
*-- Author :
C       BHATACHARIA BOUNDS CALCULATION FOR SAMPLES
C       FROM GAUSSIAN POPULATION
C       R(N*N*L)-COVARIANSE MATRIX
C       G(N*L)-MEANS
C       DB(N)-BH. DISTANSE
C       E1(N)-UPPER BOUNS
C       E2(N)-LOWER BOUNDS
C       NCOORD(N)-FEATURE EXTRACTION COD
C       NCL(L)-CLASSIES EXTRACTION CODE
C*
      SUBROUTINE BHADIS(R,G,E1,E2,E,DB,N,L)
        DIMENSION R(N*N*L),G(N,L),DB(N)
        DIMENSION E1(N),E2(N),E(N)
        S1=SQRT(R(1))
        S2=SQRT(R(2))
        S3=(R(1)+R(2))/2.
        S=S3/S1/S2
        S=ALOG(S)/2.
        DB(1)=S+(G(1,1)-G(1,2))**2/8./S3
      DO 15 I=1,N
      IF(DB(I).LT.0.)GO TO 14
      E1(I)=EXP(-DB(I))/2.
      E2(I)=0.5*(1.-SQRT(1.-4.*E1(I)**2))
      GO TO 15
14    CONTINUE
      E1(I)=0.5
      E2(I)=0.5
15    CONTINUE
C      WRITE(NT,7)(DB(II),E1(II),E2(II),II=1,N)
7     FORMAT(2X,'BHADIS',10(F9.4))
        E(1)=(G(1,1)-G(1,2))**2/S3
C
      RETURN
      END
