*CMZ :          15/04/99  09.35.19  by  Ararat Vardanyan
*-- Author :
C
C*         COVCOR
C*        CALL COVCOR(R,R3,tmin,IP,N,MB,L,NT,TEK,JMODE)
C
      SUBROUTINE COVCOR(R,A,F,IP,N,M,L,NT,TE,JMODE)
C*
C*
C*    VIZUALIZATION OF CORRELATION INFORMATION,
C*    ONE CAN OBTAIN FOLLOWING SERVICE:
C*    THE PICTURE OF CORRELATION MATRIX  ,
C*    FISHER MATRIX CHART, IN WHICH THE SIGNIFICANCE
C*    OF CORRELATION DIFFERENCIES IN ALTERNATE CLASSES
C*    OF TRAINING SAMPLE IS PLACED.
C*    INFORMATION IS DISPLAUED BY DIFFERENT SYMBOLS,
C*    BY WHICH ONE CAN SELECT STRONG CORRELATED VARIABLES
C*    OR VARIABLES,THOSE CORRELATION SIGNIFICANT DIFFERS
C*    IN STUDIED SAMPLES.
C*    R(N,N,L)-MATRIX OF COVARATIONS,
C*    A(N,N,L)-CORRELATION MATRIX,
C*    F(N,N)-FISHER MATRIX.
C*    PF,PC- CONTROL VALUES FOR SUMBOL SELECTION.
C*
C*
      DIMENSION A(N,N,L),R(N,N,L),F(N,N)
        CHARACTER*8 TE(N)
        CHARACTER*50 JMODE
        CHARACTER*50 C2,C3
C
        DATA C2/'FISHER MATRIX'/
        DATA C3/'CORRELATION MATRIX'/
c
C
      NN=N*N
      NNL=NN*L
      DO 5 K=1,L
      DO 5 I=1,N
      DO 5 J=1,N
      F(I,J)=0.
      IF(I.EQ.J) A(I,J,K)=SQRT(R(I,J,K))
      IF(I.EQ.J)GO TO5
      D1=SQRT(R(I,I,K))
      D2=SQRT(R(J,J,K))
      IF(D1.EQ.0.OR.D2.EQ.0)GO TO 5
      A(I,J,K)=R(I,J,K)/D1/D2
   5     CONTINUE
      DO 25K=1,L
       DO 25I=1,N
       DO 25J=1,N
      IF(I.EQ.J)A(I,J,K)=1.
25    CONTINUE
c
      DO 15 K1=1,N
      DO 15 K2=1,N
C
      IF(K1.EQ.K2)GO TO 15
      P1=(1+A(K1,K2,1))/(1-A(K1,K2,1))
      P2=(1+A(K1,K2,2))/(1-A(K1,K2,2))
      P3=2./(M-3)
      SZ=SQRT(P3)
      Z1=0.5*ALOG(P1)
      Z2=0.5*ALOG(P2)
      FK=(Z1-Z2)/SZ
      F(K1,K2)=ABS(FK)
15    CONTINUE
      IF(N.LE.100) then
             CALL PRT(F,N,N,1,C2,TE,TE,NT,jmode)
             CALL PRT(A,N,N,L,C3,TE,TE,NT,jmode)
       ELSE
               WRITE(nt,'(5x,''TOO MANY VARIABLES'',i5)')n
      END IF
      RETURN
       END
