*CMZ :          23/10/98  04.39.44  by  Ararat A. Vardanyan
*-- Author :
C*DK  FREAD
C=======================================================================
      SUBROUTINE FREAD(A,U,B,I1OB,NBAN,MNEW1,TEK,DEBUG,mb,m22,m33,
     *       N,NUMB,AMIN,AMAX,I1TOT,FORMAT,IFORM,ISH1,NT,ACCESS,tek3)
c_
c_____________________________________________________________________
c Reading sequential formatted (format containes in FORMAT ) files from data base
c connected with IFORM math. number, it's name is contained in T1OB.
c The first 2 lines (it1 & it2) in the bigining of data file are for information
c The third (nNTOT) - number of variables,
c The forth - number of ivents(iI1TOT),
c The fifth and sicsth(TEK) - names of variables,
c From the seventh lines data strings started with weighs after last variable.
c Data file have a relational structure with nNBAN+1 coloumns and iI1TOT rows.
c If nNTOT NE NTOT - the requested value a bug messages with code 123
c is produced and execution terminated.
c If iI1TOT NE I1TOT - the requested value only iI1TOT events will be read and
c the warning messages will be produced.
c The upper and lower boundaries to be superimposed on data variables are locate
c in AMAX and AMIN arrays, the number of selected events will appear in MNEW1.
c You can read some event sequence omitting the first ISH1 events,
c you can also read events with particular order numbers puting this numbers in
c m22 array and total number of events to be selected in MMEW1 (in the previous
c modes MNEW1 must be set to zero before calling FREAD).
c You can read also only definite variables and put them in A data array in
c desired order, the sequence of required variables have to be put in NUMB array
c For some operation modes it's necessary to have the selected events order
c  numbers this numbres are in m33 array.
c The events weights are in U array.
c N is total number of requested variables, MB - total number of expected events
c (used only in dimension declaration).
c To check read strings you can set DEBUG > 5 and the lines will be printed in
c the output file.
c At any error oe end encountered in data file a message will be generated.
c-------------------------------------------------------------------------------
c
      DIMENSION A(N*mb),U(mb),B(NBAN),m22(mb),m33(mb)
      dimension NUMB(N),AMIN(Nban),AMAX(Nban)
      CHARACTER*13 TEK(nban), tek3(nban)
      CHARACTER*50 I1OB
      CHARACTER*50 FORMAT
      CHARACTER*50 ACCESS
c
      character*50 it1,it2
c
c      write(*,'('' Starting fread, '',6i6)')nban,mnew1,mb,n,i1tot
c      write(nt,'('' Starting fread, '',6i6)')nban,mnew1,mb,n,i1tot
         OPEN (UNIT=IFORM,FILE=I1OB,FORM='FORMATTED',
     +STATUS='UNKNOWN')
came-from-mpiH     *  READonly)
came-from-KfK      *  ACTION='READ')
        REWIND IFORm
c
c
        if(ACCESS.EQ.'SEQUENTAL'.OR.ACCESS.EQ.'DELOG') then
c
      READ(IFORM,27,ERR=8) it1,it2
27    FORMAT(A80/A80)
      IF(DEBUG.GE.5.) THEN
         WRITE(NT,'(5x/'' data passport: ''/A80/A80)')
     *   it1,it2
      END IF
      READ(IFORM,7) nNBAN
7     FORMAT(5I7)
      IF(DEBUG.GE.5.) THEN
          WRITE(NT,'(/2x,''READING LINE(3) '',I7)')nNBAN
      END IF
      if(nban.ne.nnban) then
         write(8,'(//'' WRONG REQUEST OF NBAN:'',2i4)')
     * nban,nnban
      stop 213
      end if
c
      READ(IFORM,7) II1TOT
        IF(I1TOT.GT.ii1tot-ish1) THEN
          IF(DEBUG.GE.4.) THEN
           WRITE(8,'(/'' WRONG REQUEST NUMBER OF EVENTS '',2I8)')
     *     I1TOT,ii1tot-ish1
        end if
         i1tot=ii1tot-ish1
        END IF
c
      IF(DEBUG.GE.5.) THEN
         WRITE(NT,'(/2x,''READING LINE(4) '',I8)')II1TOT
      END IF
      READ(IFORM,17) (TEK3(i),i=1,nNBAN)
      IF(DEBUG.GE.4.) THEN
           WRITE(NT,'(/10x,''READING LINE(5-...) '',100(10A13/))')
     *            (TEK3(i),i=1,nNBAN)
      END IF
17    FORMAT(10A13)
C
c***   IF ACCESS is SIMPLE skip reading of header and weights
c
       else if(ACCESS.EQ.'SIMPLE') then
            nNBAN = NBAN
       end if
c
      IF(ISH1.NE.0) THEN
        DO  I=1,ISH1
         if(ACCESS.EQ.'SEQUENTAL'.OR.ACCESS.EQ.'DELOG') then
          READ(IFORM,FORMAT,ERR=8,END=98) (B(K),K=1, nNBAN),UU
         else if(ACCESS.EQ.'SIMPLE') then
            READ(IFORM,FORMAT,ERR=8,END=98) (B(K),K=1, nNBAN)
            uu=1.
         end if
        END DO
      END IF
C
      if(mnew1.ne.0) then
         mselec=1
         ii=0
      DO  I=1,I1TOT
         if(ACCESS.EQ.'SEQUENTAL'.OR.ACCESS.EQ.'DELOG') then
          READ(IFORM,FORMAT,ERR=8,END=98) (B(K),K=1, nNBAN),UU
         else if(ACCESS.EQ.'SIMPLE') then
            READ(IFORM,FORMAT,ERR=8,END=98) (B(K),K=1, nNBAN)
            uu=1.
         end if
c
           if(i.eq.m22(mselec).and.mselec.le.mnew1) then
                u(Mselec)=UU
                      DO J=1,nNban
                                         II=II+1
                                        A(II)=B(J)
                      END DO
                 mselec=mselec+1
               IF(I.le.10.AND.DEBUG.GE.5.) THEN
             WRITE(NT,'(2x,''SELECTED EVENTS ''/2(10F8.2/))')
     *      (B(K),K=1,nNBAN),UU
               ENDIF
c
           end if
       end do
c
      else if(mnew1.eq.0) then
         ii=0
          DO 5 I=1,I1TOT
             if(ACCESS.EQ.'SEQUENTAL'.OR.ACCESS.EQ.'DELOG') then
               READ(IFORM,FORMAT,ERR=8,END=98)(B(K),K=1,nNBAN),UU
             else if(ACCESS.EQ.'SIMPLE') then
               READ(IFORM,FORMAT,ERR=8,END=98)(B(K),K=1,nNBAN)
               uu=1.
             end if
              IF(I.le.10.AND.DEBUG.GE.5.) THEN
            WRITE(NT,'(/2x,''EVENT N '',i6/8(E11.4/))')
     *         i,(B(K),K=1,nNBAN),UU
             ENDIF
        DO 15 J=1,Nban
c
c   CHANGE FROM SELECTION ONLY FROM CHOOSEN VARIABLES TO _ ALL VARIABLES
c	
c            JJ=NUMB(J)
c            IF (B(JJ).LT.AMIN(J).OR.B(JJ).GT.AMAX(J)) then
              IF (B(J).LT.AMIN(J).OR.B(J).GT.AMAX(J)) then
                  IF(I.le.10.AND.DEBUG.GE.5.) THEN
              WRITE(NT,'(//2x,''Rejected EVENT, Variable '',3i7,
     *         '' bounds'',2f12.4)')i,j,jj,amin(J),amax(J)
              WRITE(NT,FORMAT) (B(K),K=1,nNBAN)
                  END IF
                  go to 5
c
            end if
15      CONTINUE
        MNEW1=MNEW1+1
      U(MNEW1)=UU
c
c     if(jmode.eq.'CLASSIFI'.or.jmode.eq.'FAST') then
         m33(mnew1)=i
c     end if
c
        DO J=1,N
          II=II+1
          JJ=NUMB(J)
          A(II)=B(JJ)
        ENDDO
5     CONTINUE

C
      end if
c
8     CONTINUE
         DO  I=1,N
          	                  TEK(I)=TEK3(NUMB(I))
c         write (nt,'(4i4,2a8)')i,numb(i),n,nban,tek(i),tek3(numb(i))
	 END DO
      close (iform)
c
      IF(DEBUG.GE.4.and.mnew1.lt.i1tot) THEN
      WRITE(NT,'(2x,''ERROR  READING LINE N  '',I7)')mnew1+I+6
      WRITE(NT,'(A80)')FORMAT
      WRITE(NT,*) b
      END IF
c
      GO TO 28
98    CONTINUE
         DO  I=1,N
          	                 TEK(I)=TEK3(NUMB(I))
 	 END DO
 	 IF(DEBUG.GE.4.) THEN
      WRITE(NT,'(2x,''END OF FILE, LINE N  '',I7)')mnew1+I+6
      WRITE(NT,'(A80)')FORMAT
      WRITE(NT,*) b
          end if
      close (iform)
c      STOP 98
28    CONTINUE
      RETURN
      END
