*CMZ :          09/04/97  12.00.24  by  Ashot Chilingarian
*-- Author :    Ashot Chilingarian   09/04/97


       subroutine sobol(A,n,m,l,ito,cmem1,cmem2,cutmin,cutmax,amax,amin,
     *search,genert,tek,nt)
c
	dimension a(n*m*l), ito(n),cmem1(n),cmem2(n), amax(n),amin(n)
	dimension cutmin(n),cutmax(n)
	character*1 wild
	character*8 tek(n*2)
                  character*6 search, genert
c
        WRITE(*,'('' You entered the HEGRA experiment data analysis
     1system ''/,'' The mode is MULTI-CUT (ANI-93 package)'')')
c
c
	qold=-999999.
	call vzero(cmem1,n)
	call vzero(cmem2,n)

c
9194	continue
        WRITE(*,'(2x,''OLD and NEW SIGMA VALUES''/ 2f14.4)') siold,sinew
c
      WRITE(*,'('' You begin the cuts optimisation in '',i3,
     *'' dimensional feature space.''/
     1'' The method used - quasi-random multidimensional search''/
     1'' is proposed by I.M.Sobol, from Russian Academy of Science,''/
     1'' Mathematical Simulation Center.''/
     2'' Enter now the random seed accyracy:  ''/
     2'' 2  integers not exceeding 1024- '')')N
c									
	read (*,*)isobol,nsobol
c
      write(*,'('' Choose the random generator: pseudo or lp-tau''/
     *5x,'' enter 1 - sobol generator, 2 - rndm(-1.)'')')
	read (*,*)igener
	if(igener.eq.1) then
		genert= 'lp-tau'
	else if (igener.eq.2) then
		genert= 'pseudo'
	end if
c
      write(*,'('' Choose the search mode sigmaa or spectr''/
     *5x,'' enter 1 - sigmaa, 2 - spectr'')')
	read (*,*)isearc
	if(isearc.eq.1) then
		search= 'sigmaa'
	else if (isearc.eq.2) then
		search= 'spectr'
	end if
c
c      WRITE(*,'('' Enter ist and add1:  ''/
c     2'' the integer not exceeding 10 and real in int. 0.01-0.1- '')')
c	read(*,*) ist,add1
c
	write(nt,'(//,64(''#'')/22x,''SOBOL STARTED''/
     *2x,''Parameters ( seed size,generator,search mode:''/
     * 2x,2i5,2a8/)')
     * nsobol,isobol,genert,search
c
            CALL TIMED(TIME)
          WRITE(NT,'(/2X,''BEFORE CALL SOBOL '',A8,2X,A8)')NDATA,NTIME
         WRITE(*,'(/2X,''BEFORE CALL SOBOL '',A8,2X,A8)')
     * NDATA,NTIME
C
	do is=1,isobol
c	
	if(genert.eq.'lp-tau')then
		call lptau(is,n,cutmin)
	else if(genert.eq.'pseudo') then
		do ii=1,n
			RANDOM=RNDM(-1.)
			cutmIN(ii)= RANDOM
	if(debug.ge.4) then
		WRITE(NT,'('' CUTMIN(RNDM):'',I6,10E12.4)')
     *  JS,RANDOM
	END IF
		end do
	end if
c
     	if(debug.ge.4) then
		WRITE(NT,'('' CUTMIN (PRIMARY):'',I6,10E12.4)')
     *  IS,(CUTMIN(II),II=1,N)
	END IF
c
		do ii=1,n
                 cutmin(ii)=amin(ii)+cutmin(ii)*(amax(ii)-amin(ii))
		end do
C
	      	do js=1,nsobol
c	
	if(genert.eq.'lp-tau')then
		call lptau(js,n,cutmax)
	else if(genert.eq.'pseudo') then
		do ii=1,n
			RANDOM=RNDM(-1.)
			cutmax(ii)= RANDOM
	if(debug.ge.4) then
		WRITE(NT,'('' CUTMAX(RNDM):'',I6,10E12.4)')
     *  JS,RANDOM
	END IF
c
		end do
	end if
c
	if(debug.ge.4) then
		WRITE(NT,'('' CUTMAX(PRIMARY):'',I6,10E12.4)')
     *  JS,(CUTMAX(II),II=1,N)
	END IF
		do ii=1,n
	  cutmax(ii)=cutmax(ii)*(amax(Ii)-cutmin(Ii))+cutmin(ii)
		end do
c
		if(is*js.eq.1) then
			do ii=1,n
			cutmin(ii)=amin(ii)
			cutmax(ii)=amax(ii)
			end do
		end if
	call cutsob   (a,N,ITO(1),ion,cutmin,cutmax)
        call cutsob   (a(n*ITO(1)+1),N,ITO(2),ioff,cutmin,cutmax)
c
		dif=real(ion-ioff)
		sum=real(ion+ioff)
		if(sum.ne.0.) then
			signew=dif/sqrt(sum)
		else
			signew =0
		end if
c
	if (search.eq.'spectr') then	
		qnew=dif
	else if(search.eq.'sigmaa') then
		qnew=signew
	end if
c
	if(qnew.gt.qold) then
		qold=qnew
c	if(is*js.ne.1) then
		call ucopy(cutmin,cmem1,n)
		call ucopy(cutmax,cmem2,n)
                ionmem=ion
                iofmem=ioff
                difmem=dif
c
		if(debug.ge.2) then
	write(nt,'('' ON and OFF, DIFF and SIGMA:''/2x,2i8,2f12.4)')
     * ionmem,iofmem,difmem,signew
c
	write(*,'('' successful step N '',i7, '' obtain cuts:''/
     *,50(2X,E12.4,'' < '',A8,'' <'',E12.4/))')
     *   (is-1)*nsobol+js,(cmem1(I),TEK(I),cmem2(I),I=1,N)
c
	write(*,'('' ON and OFF, DIFF and SIGMA:''/2x,2i5,f5.0,f9.4)')
     * ionmem,iofmem,difmem,signew
	write(nt,'('' successful step N '',i7, '' obtain cuts:''/
     *,50(2X,E12.4,'' < '',A8,'' <'',E12.4/))')
     *   (is-1)*nsobol+js,(cmem1(I),TEK(I),cmem2(I),I=1,N)
c
	    	end if
c	     end if
	else if(qnew.le.qold.and.debug.ge.3) then
C
	write(*,'('' Faluire N '',3i7, '' obtain cuts:''/
     *,50(2X,E12.4,'' < '',A8,'' <'',E12.4/))')
     * is,js,  (is-1)*nsobol+js,(cutmin(I),TEK(I),cutmax(I),I=1,N)
	write(*,'('' ON and OFF, DIFF and SIGMA:''/2x,2i5,f5.0,f7.4)')
     * ionmem,iofmem,difmem,signew
	write(nt,'('' Failuire N '',3i7, '' obtain cuts:''/
     *,50(2X,E12.4,'' < '',A8,'' <'',E12.4/))')
     * is,js,  (is-1)*nsobol+js,(cutmin(I),TEK(I),cutmax(I),I=1,N)
	write(nt,'('' ON and OFF, DIFF and SIGMA:''/2x,2i5,f5.0,f7.4)')
     * ionmem,iofmem,difmem,signew
c
	end if
		end do
	end do
c
            CALL TIMED(TIME)
             CALL DATIMH(NDATA,NTIME)
             WRITE(NT,'(/2X,''SOBOL FINISHS AT '',A8,2X,A8,
     *'' CPU TIME'',E18.8)') NDATA,NTIME,TIME
            WRITE(*,'(/2X,''SOBOL FINISHS AT '',A8,2X,A8,
     *'' CPU TIME'',E18.8)') NDATA,NTIME,TIME
c
	write(nt,'('' Seed size and generator used:''/2x,2i5,a8)')
     * nsobol,isobol,genert
c
	WRITE(*,'(/'' Do you whant to continue search?,
     * enter y or n '')')
	read (*,'(A1)') wild
	if (wild.eq.'n') then
	write(*,'('' The best obtain cuts values:''/
     *,50(2X,E12.4,'' < '',A8,'' <'',E12.4/))')
     *(cmem1(I),TEK(I),cmem2(I),I=1,N)
	write(*,'('' ON and OFF, DIFF and SIGMA:''/2x,2i5,f5.0,f7.4)')
     * ionmem,iofmem,difmem,qold
c
	write(nt,'('' The best obtain cuts values:''/
     *,50(2X,E12.4,'' < '',A8,'' <'',E12.4/))')
     *(cmem1(I),TEK(I),cmem2(I),I=1,N)
	write(nt,'('' Seed size and generator used:''/2x,2i5,a8)')
     * nsobol,isobol,genert
c
	write(nt,'('' ON and OFF, DIFF and SIGMA:''/2x,2i5,f5.0,f7.4)')
     * ionmem,iofmem,difmem,qold
c
        WRITE(*,'(//15x,'' Thank you for using ANI package''/
     * 12x,''you can have a look on output file B.OUT''/
     *  14x,''where the protocol of run is printed'')')
	stop 942
	else if (wild.eq.'y') then
	write(*,'('' The best obtain cuts values:''/
     *,50(2X,E12.4,'' < '',A8,'' <'',E12.4/))')
     *(cmem1(I),TEK(I),cmem2(I),I=1,N)
	write(*,'('' ON and OFF, DIFF and SIGMA:''/2x,2i5,f5.0,f7.4)')
     * ionmem,iofmem,difmem,qold
c
	write(nt,'('' The best obtain cuts values:''/
     *,50(2X,E12.4,'' < '',A8,'' <'',E12.4/))')
     *(cmem1(I),TEK(I),cmem2(I),I=1,N)
	write(nt,'('' ON and OFF, DIFF and SIGMA:''/2x,2i5,f5.0,f7.4)')
     * ionmem,iofmem,difmem,qold
c

         go to 9194
	end if
c
   	return
   	end
