*CMZ :          13/06/98  19.01.59  by  Ararat Vardanyan
*-- Author :
C
C
C       BHATACHARIA DISTANSE RB = RM/8 + RC/2
C       R(N*N*L)-COV. M.
C       G(N*L)-MEANS
C       E(N*N)-MUATIAL COV. M
C       RC CORRELATION DISTANCE
C       RM MAHALONOBIS DISTANCE

      SUBROUTINE BHAFAS(R,G,E,E1,E2,E3,RB,RM,RC,N)
      DIMENSION R(N*N*2),G(N,2),E(N,N),E1(N*N),E2(N*N),E3(N*N)
      CALL VADD(R,R(N*N+1),E,N*N)
      CALL VSCALE(E,0.5,E,N*N)
      CALL UCOPY(E,E3,N*N)
      CALL UCOPY(R,E1,N*N)
      CALL UCOPY(R(N*N+1),E2,N*N)
C        WRITE(2,7)R,E1,E2,E3,E
7       FORMAT(2X,16(8F8.5/))
      RCC=DET(E3,N,N)**2/DET(E1,N,N)/DET(E2,N,N)
      IF(RCC.LE.1.E-19)THEN
      WRITE(8,'(5X,''ATTENSION RCC.LE-'',E20.4)')RCC
      RCC=1.E-19
      END IF
      RC=ALOG(RCC)
c      CALL SMXINV(E,N,IF)
      call RSINV(N,E,N,IF)
      RM=0.
      DO 15 I=1,N
      DO 15 J=1,N
      DG1=G(I,1)-G(I,2)
      DG2=G(J,1)-G(J,2)
      RM=RM+E(I,J)*DG1*DG2
15    CONTINUE
      RB=RC/4.+RM/8.
c       WRITE(2,17)RM,RC
17       FORMAT(2X,'RMAHALO AND CORCOR',10F7.3)
      RETURN
      END
