*CMZ :          10/04/98  15.15.12  by  Ararat Vardanyan
*-- Author :
C
C
C       BHATACHARIA DISTANSE = RM/8 + RC/4
C       R(N*N*L)-COV. M.
C       G(N*L)-MEANS
C       E1(N*N),E2(N*N)-CURRENT VALUES OF COV. MATRIX
C       E(N*N)-MUTUAL COV. M
C       RC CORRELATION DISTANCE
C       RM MAHALONOBIS DISTANCE

      SUBROUTINE MAHALO(R,G,E,E1,E2,E3,RM,RC,N,ID)
      DIMENSION R(N,N,2),G(N,2),E(ID,ID),E1(ID,ID),E2(ID,ID)
     *,E3(ID,ID)
        DO 85 I=1,ID
        DO 85 J=1,ID
      E1(I,J)=R(I,J,1)
      E2(I,J)=R(I,J,2)
85     CONTINUE
      CALL VADD(E1,E2,E,ID*ID)
      CALL VSCALE(E,0.5,E,ID*ID)
      CALL UCOPY(E,E3,ID*ID)
C        WRITE(2,7)R,E1,E2,E3,E
7       FORMAT(2X,16(8F8.5/))
      RCC=DET(E3,ID,ID)**2/DET(E1,ID,ID)/DET(E2,ID,ID)
      IF(RCC.LE.1.E-30)THEN
      WRITE(8,'(5X,''ATTENSION RCC.LE-'',E12.4)')RCC
      RCC=1.E-30
      END IF
      RC=ALOG(RCC)
      RC=RC
c      CALL SMXINV(E,ID,IF)
      call RSINV(ID,E,ID,IF)
      RM=0.
      DO 15 I=1,ID
      DO 15 J=1,ID
      DG1=G(I,1)-G(I,2)
      DG2=G(J,1)-G(J,2)
      RM=RM+E(I,J)*DG1*DG2
15    CONTINUE
C      WRITE(2,17)RM,RC
17       FORMAT(2X,'RMAHALO AND CORCOR',10F7.3)
      RETURN
      END
