*CMZ :          04/04/97  12.54.33  by  Markus Roth
*-- Author :
      SUBROUTINE MISR1(A,ABAR,R,V,N,ITO,MB,L)
C*
C
C*    MEAN AND COVARIANCE MATRIX CALCULATION,
C*    (EVENTS HAVE NONEQUAL WEIGHTS).
C
      DIMENSION A(N*MB),R(N*N*L),ABAR(N*L)
      DIMENSION V(MB),ITO(L)
C
C*    A(N*MB)-TRAINING SAMPLE,
C     V(MB) - WEIGHTS OF TS MEMBERS,
C*    N-NUMBER OF VARIABLES,
C*    MB- TOTAL NUMBER OF EVENTS(SAMPLE SIZE),
C     ITO(L) - NUMBER OF EVENTS IN TS CLASSES,
C*    L- NUMBER OF CLASSES
C*    R(N*N*L)-COVARIANCE MATRIX
C
      LK=0
      LI=0
      LJ=0
      LJJ=0
      K1=0
      J1=0
C*    ABAR(N,L)-MEAN MATRIX
C*    MEAN CALCULATION
C
      MH=1
      MV=0
      DO 55 L1=1,L
      MV=MV+ITO(L1)
      IF(L1.NE.1) then
              MH=MH+ITO(L1-1)
      END IF
      DO 20 J=1,N
      LL=(L1-1)*N+J
      ABAR(LL)=0.
      K=(MH-1)*N-N+J
      DO 15 I=MH,MV
      K=K+N
      ABAR(LL)=ABAR(LL)+A(K)*V(I)
c        write(*,'(3x,''Debuging A,V'',/,2f7.4//)') A(k),V(i)
15    CONTINUE
20    CONTINUE
C
C*    COVARIADCES CALCULATION
C
      DO 55 J=1,N
      J1=J1+1
      I1=(L1-1)*N
      LJJ=(MH-1)*N-N+J
      DO 55 I=1,N
      I1=I1+1
      TIJ=0.
      LI=(MH-1)*N-N+I
      LJ=LJJ
      LK=LK+1
      DO 35 J35=MH,MV
      LI=LI+N
      LJ=LJ+N
      XX=A(LI)-ABAR(I1)
      YY=A(LJ)-ABAR(J1)
      XX=XX*V(J35)
      TIJ=TIJ+XX*YY
35    CONTINUE
      R(LK)=TIJ
55    CONTINUE
      RETURN
      END

















